Skip to content

Latest commit

 

History

History
55 lines (44 loc) · 3.39 KB

[LeetCode] 11. Container With Most Water.md

File metadata and controls

55 lines (44 loc) · 3.39 KB

Description

Given n non-negative integers a, a, ..., a, where each represents a point at coordinate (i, a). n vertical lines are drawn such that the two endpoints of line i is at (i, a) and (i, 0). Find two lines, which together with x-axis forms a container, such that the container contains the most water. **Note: **You may not slant the container and n is at least 2.   The above vertical lines are represented by array [1,8,6,2,5,4,8,3,7]. In this case, the max area of water (blue section) the container can contain is 49.   Example:

Input: [1,8,6,2,5,4,8,3,7]
Output: 49

Solution

Approach 2: Two Pointer Approach

Algorithm The intuition behind this approach is that the area formed between the lines will always be limited by the height of the shorter line. Further, the farther the lines, the more will be the area obtained. We take two pointers, one at the beginning and one at the end of the array constituting the length of the lines. Futher, we maintain a variable \text{maxarea}maxarea to store the maximum area obtained till now. At every step, we find out the area formed between them, update \text{maxarea}maxarea and move the pointer pointing to the shorter line towards the other end by one step. The algorithm can be better understood by looking at the example below:

1 8 6 2 5 4 8 3 7

How this approach works? Initially we consider the area constituting the exterior most lines. Now, to maximize the area, we need to consider the area between the lines of larger lengths. If we try to move the pointer at the longer line inwards, we won't gain any increase in area, since it is limited by the shorter line. But moving the shorter line's pointer could turn out to be beneficial, as per the same argument, despite the reduction in the width. This is done since a relatively longer line obtained by moving the shorter line's pointer might overcome the reduction in area caused by the width reduction. For further clarification click here and for the proof click here.

解题思路:

  1. 初始起点 i = 0 ,终点 j = n - 1 ,计算出此时的容积
  2. 然后移动 i 和 j 得到其他情况下的体积,计算最大值。要得到尽可能大的容积,需要移动 i 和 j 中高度更短的点。因为容积是 i 和 j 中高度较短的边决定的( min(height[i], height[j]) * (j - i)) ),移动高度更长的边并不能增加容积,只有移动短边才有可能得到更大的容积。
public class Solution {
    public int maxArea(int[] height) {
        int maxWater = 0;
        int i = 0, j = height.length - 1;
        while (i < j) {
            maxWater = Math.max(maxWater, (j - i) * Math.min(height[i], height[j]));
            if (height[i] < height[j]) i++;
            else j--;
        }

        return maxWater;
    }
}

Complexity Analysis

  • Time complexity : O(n)O(n). Single pass.

  • Space complexity : O(1)O(1). Constant space is used.